package cn.iocoder.yudao.module.bpm.service.oa;

import cn.iocoder.yudao.module.bpm.controller.admin.oa.vo.refund.BpmOARefundCreateReqVO;
import cn.iocoder.yudao.module.bpm.dal.dataobject.oa.BpmOARefundDO;

import javax.validation.Valid;
import java.util.List;

public interface BpmOARefundService {

    /**
     * 创建退款申请
     *
     * @param userId 用户编号
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createRefund(Long userId, @Valid BpmOARefundCreateReqVO createReqVO);

    /**
     * 更新退款申请的状态
     *
     * @param id 编号
     * @param result 结果
     */
    void updateRefundResult(String processInstanceId, Long id, Integer result);

    /**
     * 获得退款申请
     *
     * @param id 编号
     * @return 退款申请
     */
    BpmOARefundDO getRefund(Long id);

    /**
     * 获得指定的退款申请
     * @param processInstanceId 流程实例编号
     * @return 退款申请
     */
    BpmOARefundDO getByProcessInstanceId(String processInstanceId);

    /**
     * 获得指定的退款申请列表
     * @param orderNos 订单编号
     * @return 退款申请列表
     */
    List<BpmOARefundDO> getListByOrderNo(List<String> orderNos);

    /**
     * 更新退款申请状态
     * @param orderNo 订单编号
     */
    void updateStatus(String orderNo);
}
